#include "imgui_main.h"
#include "widget/login.h"
#include "widget/main_page.h"

bool is_login = false;

std::string get_window_title() {
    return "Inspur BMC";
}

// 配置imgui, 比如加载字体, 启用多视口等
void configure_imgui(ImGuiIO& io) {
    io.ConfigFlags |= ImGuiConfigFlags_NavEnableKeyboard;        // Enable Keyboard Controls
    io.ConfigFlags |= ImGuiConfigFlags_NavEnableGamepad;         // Enable Gamepad Controls
    io.ConfigFlags |= ImGuiConfigFlags_DockingEnable;            // Enable Docking
    io.ConfigFlags |= ImGuiConfigFlags_ViewportsEnable;          // Enable Multi-Viewport / Platform Windows
    io.ConfigViewportsNoAutoMerge = false;

    float dpi_scale = get_dpi_scale();

    io.Fonts->AddFontFromFileTTF("resources/GenJyuuGothic-Normal-2.ttf", 18.0f * dpi_scale);
}

// 执行一些数据更新代码在这里
void tick_imgui(float delta_time) {
    update_infos();
}

// 执行imgui绘制(在tick_imgui之后执行)
void draw_imgui(float delta_time) {
    ImGui::DockSpaceOverViewport();
    if (is_login)
        draw_page();
    else
        draw_login();
}

int main(int argc, char *argv[]) {
    run_imgui();
    task_executor<logout_task>::sync_run_task();
    return 0;
}
