#pragma once
#include <future>

#include "data_types.h"
#include "imgui.h"
#include "request_task.h"
#define BUF_SIZE 256

extern bool is_login;
inline char ip_buf[BUF_SIZE] { "192.168.1.10" };
inline char username_buf[BUF_SIZE] { "admin" };
inline char password_buf[BUF_SIZE] { "admin" };
inline std::future<session_data> login_future;

inline void draw_login() {
     if (is_login)
        return;
    ImGui::Begin("Login");
    ImGui::Text("BMC IP: ");
    ImGui::SameLine();
    ImGui::InputText("##bmc_ip", ip_buf, BUF_SIZE);
    ImGui::NewLine();

    ImGui::Text("User: ");
    ImGui::SameLine();
    ImGui::InputText("##user", username_buf, BUF_SIZE);
    ImGui::NewLine();

    ImGui::Text("Password: ");
    ImGui::SameLine();
    ImGui::InputText("##password", password_buf, BUF_SIZE);
    ImGui::NewLine();

    if (ImGui::Button("Login")) {
        if (!login_future.valid())
            login_future = task_executor<login_task>::run_task(ip_buf, username_buf, password_buf);
    }
    if (login_future.valid()) {
        ImGui::Text("Logging in...");
        if (login_future.wait_for(std::chrono::seconds(0)) == std::future_status::ready) {
            session_data session = login_future.get();
            if (session.session_cookie.empty()) {
                ImGui::Text("Login failed");
            } else {
                is_login = true;
                ImGui::Text("Login success");
            }
        }
    }
    ImGui::End();
}
